#include "DEM.h"

#if 0
#define DEBUG_generate_vertices_math_order
#endif

#if 0
#define PRINT_VERTICES
#endif

#define DEBUG_generate_vertices
#define DEBUG_generate_triangle

void generate_vertices(int Datafile, DEM_record **Records, int LL_x, int LL_y,
                       int UR_x, int UR_y)
{
   int          M;
   int          N;
   int          i;
   int          j;
   int          Index;
   int         *Left_Elevations;
   int         *Right_Elevations;
   int          Left_Corner_0;
   int          Left_Corner_1;
   int          Right_Corner_0;
   int          Right_Corner_1;
   double       Horz_mid_0;
   double       Horz_mid_1;
   double       Vert_mid_0;
   double       Vert_mid_1;
   double       Center_0;
   double       Center_1;
   double       Center;

   int          Num_Vertices_per_Column;
   int          Total_Num_Vertices;
   double     **Column1;
   double     **Column2;
   double      *Pointer1;
   double      *Pointer2;
   char        *Buffer;
   int          Buffer_Size;

   M = UR_y - LL_y + 1;
   N = UR_x - LL_x + 1;

   Num_Vertices_per_Column = M + (M - 1);

   if ((Column1 = (double **) malloc(Num_Vertices_per_Column * 2
                                     * sizeof(double *))) == NULL)
   {
      perror("generate_vertices()");
      exit(1);
   }

   Column2 = Column1 + Num_Vertices_per_Column;

   Buffer_Size = 2 * Num_Vertices_per_Column * 3 * sizeof(double);

   if ((Buffer = (char *) malloc(Buffer_Size)) == NULL)
   {
      perror("generate_vertices()");
      exit(1);
   }

   Pointer1 = (double *) Buffer;
   Pointer2 = Pointer1 + (Num_Vertices_per_Column * 3);

   for (i = 0, Index = 0; i < Num_Vertices_per_Column; i++, Index += 3)
   {
      Column1[i] = &(Pointer1[Index]);
      Column2[i] = &(Pointer2[Index]);
   }

   Total_Num_Vertices  = (N + (N - 1)) * Num_Vertices_per_Column;

   write(Datafile, &Total_Num_Vertices, sizeof(int));

#if defined(DEBUG_generate_vertices) || defined(DEBUG_generate_vertices_math_order)
#if 0
   fprintf(stderr, "Total_Num_Vertices = %d\n", Total_Num_Vertices);
#endif
   printf("%d\n", Total_Num_Vertices);
#endif

   for (j = LL_x; j <= UR_x - 1; j++)
   {
      Left_Elevations = (Records[j]) -> Elevations;
      Right_Elevations = (Records[j + 1]) -> Elevations;

      for (i = LL_y, Index = 0; i <= UR_y - 1; i++)
      {
         Left_Corner_0 = Left_Elevations[i];
         Right_Corner_0 = Right_Elevations[i];
         Right_Corner_1 = Right_Elevations[i + 1];
         Left_Corner_1 = Left_Elevations[i + 1];
         
         Horz_mid_0 = ((double) (Left_Corner_0 + Right_Corner_0)) / 2.0;
         Horz_mid_1 = ((double) (Left_Corner_1 + Right_Corner_1)) / 2.0;

         Center_0 = (Horz_mid_0 + Horz_mid_1) / 2.0;

         Vert_mid_0 = ((double) (Left_Corner_0 + Left_Corner_1)) / 2.0;
         Vert_mid_1 = ((double) (Right_Corner_0 + Right_Corner_1)) / 2.0;

         Center_1 = (Vert_mid_0 + Vert_mid_1) / 2.0;

         Center = (Center_0 + Center_1) / 2.0;

#ifdef DEBUG_generate_vertices_0
         printf("%lf %lf %lf\n", (double) (j), (double) (i),
                (double) Left_Corner_0);
         printf("%lf %lf %lf\n", (double) (j), (double) (i) + 0.5,
                (double) Vert_mid_0);
         printf("%lf %lf %lf\n", (double) (j) + 0.5, (double) (i),
                Horz_mid_0);
         printf("%lf %lf %lf\n", (double) (j) + 0.5, (double) (i) + 0.5,
                Center);
#endif

         Column1[Index][0] = (double) (j);
         Column1[Index][1] = (double) Left_Corner_0;
         Column1[Index][2] = (double) (i);

#ifdef DEBUG_generate_vertices_1
         printf("%lf %lf %lf\n", (double) (j), (double) (i),
                (double) Left_Corner_0);
#endif
         Column2[Index][0] = (double) (j) + 0.5;
         Column2[Index][1] = (double) Horz_mid_0;
         Column2[Index][2] = (double) (i);

         Index++;

         Column1[Index][0] = (double) (j);
         Column1[Index][1] = (double) Vert_mid_0;
         Column1[Index][2] = (double) (i) + 0.5;

         Column2[Index][0] = (double) (j) + 0.5;
         Column2[Index][1] = (double) Center;
         Column2[Index][2] = (double) (i) + 0.5;

         Index++;
      }

#ifdef DEBUG_generate_vertices_0
      printf("%lf %lf %lf\n", (double) (j), (double) (i),
             (double) Left_Corner_0);
      printf("%lf %lf %lf\n", (double) (j) + 0.5, (double) (i),
             Horz_mid_1);
#endif
      Column1[Index][0] = (double) (j);
      Column1[Index][1] = (double) Left_Corner_1;
      Column1[Index][2] = (double) (i);

#ifdef DEBUG_generate_vertices_1
      printf("%lf %lf %lf\n", (double) (j), (double) (i),
             (double) Left_Corner_1);
#endif
      Column2[Index][0] = (double) (j) + 0.5;
      Column2[Index][1] = (double) Horz_mid_1;
      Column2[Index][2] = (double) (i);

#ifdef DEBUG_generate_vertices_math_order
      for (i = 0; i < Num_Vertices_per_Column; i++)
         printf("%lf %lf %lf\n", Column1[i][0], Column1[i][2], Column1[i][1]);
      for (i = 0; i < Num_Vertices_per_Column; i++)
         printf("%lf %lf %lf\n", Column2[i][0], Column2[i][2], Column2[i][1]);
#endif
#ifdef DEBUG_generate_vertices
      for (i = 0; i < Num_Vertices_per_Column; i++)
         printf("%lf %lf %lf\n", Column1[i][0], Column1[i][1], Column1[i][2]);
      for (i = 0; i < Num_Vertices_per_Column; i++)
         printf("%lf %lf %lf\n", Column2[i][0], Column2[i][1], Column2[i][2]);
#endif
#ifdef PRINT_VERTICES
      for (i = 0; i < Num_Vertices_per_Column; i++)
         printf("%lf\n", Column1[i][2]);
      for (i = 0; i < Num_Vertices_per_Column; i++)
         printf("%lf\n", Column2[i][2]);
#endif
      write(Datafile, Buffer, Buffer_Size);
   }

   for (i = LL_y, Index = 0; i <= UR_y - 1; i++)
   {
      Vert_mid_0 = ((double) (Right_Elevations[i] + Right_Elevations[i + 1]))
                   / 2.0;

#ifdef DEBUG_generate_vertices_0
      printf("%lf %lf %lf\n", (double) (UR_x), (double) i,
             (double) Right_Elevations[i]);
      printf("%lf %lf %lf\n", (double) (UR_x), (double) i + 0.5,
             Vert_mid_0);
#endif

      Column1[Index][0] = (double) (UR_x);
      Column1[Index][1] = (double) Right_Elevations[i];
      Column1[Index][2] = (double) (i);

#ifdef DEBUG_generate_vertices_1
      printf("*%lf %lf %lf\n", (double) (UR_x - 1), (double) i,
             (double) Right_Elevations[i]);
#endif
      Index++;

      Column1[Index][0] = (double) (UR_x);
      Column1[Index][1] = (double) Vert_mid_0;
      Column1[Index][2] = (double) (i) + 0.5;

      Index++;
   }

   Column1[Index][0] = (double) (UR_x);
   Column1[Index][1] = (double) Right_Elevations[i];
   Column1[Index][2] = (double) (i);

#ifdef DEBUG_generate_vertices_1
   printf("%lf %lf %lf\n", (double) (UR_x), (double) i,
          (double) Right_Elevations[i]);
#endif
#ifdef DEBUG_generate_vertices_math_order
   for (i = 0; i < Num_Vertices_per_Column; i++)
      printf("%lf %lf %lf\n", Column1[i][0], Column1[i][2], Column1[i][1]);
#endif
#ifdef DEBUG_generate_vertices
   for (i = 0; i < Num_Vertices_per_Column; i++)
      printf("%lf %lf %lf\n", Column1[i][0], Column1[i][1], Column1[i][2]);
#endif
#ifdef PRINT_VERTICES
   for (i = 0; i < Num_Vertices_per_Column; i++)
      printf("%lf\n", Column1[i][2]);
#endif

   write(Datafile, Buffer, Buffer_Size / 2);

   free(Buffer);
   free(Column1);
}



/*
 *                    (M - 1, N - 1)
 *      ^             ur_x, ur_y
 *      |
 *      |
 *      |
 *      |
 *      |
 *(0, 0)|------------->
 * ll_x, ll_y
 */

void generate_triangle(int Datafile, int M, int N)
{
   int   M_Limit;
   int   N_Limit;

   int   Num_Polygons_per_Column;
   int   Total_Num_Polygons;

   int   Buffer_Size;
   char *Buffer;
   int  *int_Pointer;

   int   i;
   int   j;
   int   Index;

   int   Base;
   int   Factor;

   int **Polygons;

   M = M + (M - 1);
   N = N + (N - 1);
   M_Limit = M - 1;
   N_Limit = N - 1;

   Num_Polygons_per_Column = 2 * M_Limit;

   Total_Num_Polygons = N_Limit * Num_Polygons_per_Column;

   if ((Polygons = (int **) malloc(Num_Polygons_per_Column * sizeof(int *)))
       == NULL)
   {
      perror("generate_triangle()");
      exit(1);
   }

   Buffer_Size = Num_Polygons_per_Column * 3 * sizeof(int);

   if ((Buffer = (char *) malloc(Buffer_Size)) == NULL)
   {
      perror("generate_triangle()");
      exit(1);
   }

   int_Pointer = (int *) Buffer;

   for (i = 0, Index = 0; i < Num_Polygons_per_Column; i++, Index += 3)
      Polygons[i] = &(int_Pointer[Index]);

#ifdef DEBUG_generate_triangle
#if 0
   printf("Total_Num_Polygons = %d\n", Total_Num_Polygons);
#endif
   printf("%d\n", Total_Num_Polygons);
#endif

   write(Datafile, &Total_Num_Polygons, sizeof(int));

   for (i = 0, Base = 0; i < N_Limit; i++, Base += M)
   {
      Index = 0;
      for (j = 0; j < M_Limit; j++)
      {
         Factor = Base + j;
#ifdef DEBUG_generate_triangle
         printf("%d %d %d\n", Factor, Factor + M + 1, Factor + M);
#endif
         Polygons[Index][0] = Factor;
         Polygons[Index][1] = Factor + M + 1;
         Polygons[Index][2] = Factor + M;
         Index++;

#ifdef DEBUG_generate_triangle
         printf("%d %d %d\n", Factor, Factor + 1, Factor + M + 1);
#endif
         Polygons[Index][0] = Factor;
         Polygons[Index][1] = Factor + 1;
         Polygons[Index][2] = Factor + M + 1;
         Index++;
      }
      write(Datafile, Buffer, Buffer_Size);
   }

   free(Buffer);
   free(Polygons);
}
